image: thecodingmachine/php:7.2-v4-cli-node18

before_script:
    - composer install

cache:
    paths:
        - vendor/

stages:
    - SecurityChecker
    - CodingStandards
    - UnitTests
    - lint 
security-checker:
    stage: SecurityChecker
    script:
        - local-php-security-checker  --path=./composer.lock
    allow_failure: false

phpcs:
    stage: CodingStandards
    script:
        - phpcs -v --standard=PSR12 --ignore=./src/Kernel.php ./src
    allow_failure: false

phpstan:
    stage: CodingStandards
    script:
        - phpstan analyse ./src
    allow_failure: false

phpunit:
    stage: UnitTests
    script:
        - php bin/phpunit
    allow_failure: false
lint:php:
  stage: lint
  script:
    - npm install -g megalinter
    - megalinter --config=php.json --exclude=vendor --paths='**/*.php' --format=json > lint-report-php.json

lint:scss:
  stage: lint
  script:
    - npm install -g megalinter
    - megalinter --config=scss.json --paths='**/*.scss' --format=json > lint-report-scss.json

lint:js:
  stage: lint
  script:
    - npm install -g megalinter
    - megalinter --config=js.json --paths='**/*.js' --format=json > lint-report-js.json

lint:ts:
  stage: lint
  script:
    - npm install -g megalinter
    - megalinter --config=ts.json --paths='**/*.ts' --format=json > lint-report-ts.json

send_report:
  stage: lint
  script:
    - apt-get update -qy
    - apt-get install -y mailutils
    - echo "Lint report attached" | mail -a lint-report-*.json -s "Lint report" semah.fejjari@gmail.com